#include <dbus/dbus-glib.h>
#include <stdlib.h>
#include <limits.h>

#include "xcpmd_server_obj.h"
#include "xcpmd_server_marshall.h"

extern const DBusGObjectInfo dbus_glib_xcpmd_object_info;
DBusGObjectInfo dbus_glib_xcpmd_object_info_modified;

G_DEFINE_TYPE (XcpmdObject, xcpmd_object, G_TYPE_OBJECT);

enum {
  PROP_0,
  
  N_PROPERTIES
};

static GParamSpec *obj_properties[N_PROPERTIES] = { NULL, };

static void
handle_set_property(GObject *obj, guint propid, const GValue *value, GParamSpec *spec)
{
    XcpmdObject *self = XCPMD_OBJECT (obj);
    (void) self;
    switch (propid) {
    
    }
}

static void
handle_get_property(GObject *obj, guint propid, GValue *value, GParamSpec *spec)
{
    XcpmdObject *self = XCPMD_OBJECT (obj);
    (void) self;
    switch (propid) {
    
    }
}

static void xcpmd_object_init (XcpmdObject *obj)
{
}

static void xcpmd_object_class_init (XcpmdObjectClass *klass)
{
    GObjectClass *gc = G_OBJECT_CLASS(klass);
    
    gc->set_property = handle_set_property;
    gc->get_property = handle_get_property;
    if (N_PROPERTIES > 1)
      g_object_class_install_properties(gc, N_PROPERTIES, obj_properties);
}

XcpmdObject *xcpmd_create_glib_obj()
{
    dbus_glib_xcpmd_object_info_modified = dbus_glib_xcpmd_object_info;
    dbus_glib_xcpmd_object_info_modified.exported_signals = "\0";
    dbus_g_object_type_install_info(XCPMD_TYPE_OBJECT, &dbus_glib_xcpmd_object_info_modified);
    return g_object_new(XCPMD_TYPE_OBJECT, NULL);
}

XcpmdObject *xcpmd_export_dbus(DBusGConnection *conn, const char *path)
{
    XcpmdObject *obj = xcpmd_create_glib_obj();
    if (!obj) {
        return NULL;
    }
    dbus_g_connection_register_g_object(conn, path, G_OBJECT(obj));
    return obj;
}
